#Copyright 2008 Alexander Exner

#This file is part of WebcamDemo.

#WebcamDemo is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.

#WebcamDemo is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with WebcamDemo.  If not, see <http://www.gnu.org/licenses/>.

import time
  
class FpsControl:
    def __init__(self, maxfps = None):
        self.mincycle = None if maxfps is None else 1.0 / maxfps
        self.tlast = time.time()
        self.boundary = self.tlast
        self.count = 0
        self.returned = 0
          
    def go(self):
        self.count = self.count + 1
        t = time.time()
        
        if self.mincycle is not None:
            tdiff = self.mincycle - (t - self.tlast)
            if tdiff > 0:
                time.sleep(tdiff)
                #pygame.time.delay((int)(tdiff * 1000))
                t = time.time()
            self.tlast = t
        
        if t - self.boundary > 1:
            self.boundary = t
            self.returned = self.count
            self.count = 0
           
        return self.returned
